<?php
namespace youlead\Helper;

abstract class Config
{
    const
        ClientId  = 'yl_client_id',
        AppId     = 'yl_app_id',
        SecretKey = 'yl_secret_key',
        YlLoggingEnabled = 'yl_log_enabled',
        YlBlockingTrackCookie = 'yl_blocking_track_cookie_enabled',
        LogName = 'ylLogs.log',
        LogPath = WP_CONTENT_DIR . '/' . self::LogName,
        YLAttrMap = 'yl_attr_map',
        YLCookieBotName = 'yl_cookie_bot_name',
        YLCookieBotAttrMap = 'yl_cookie_bot_attr_map',
        YLCookieBotSeparator = 'yl_cookie_bot_separator';


    public function isActive()
    {
        $clientId = get_option(self::ClientId);
        $appId = get_option(self::AppId);
        $sk = get_option(self::SecretKey);

        return $clientId && $appId && $sk ? true : false;
    }

    public function isLoggingEnabled()
    {
        return get_option(self::YlLoggingEnabled) ? true : false;
    }
    public function isBlockingTrackCookie()
    {
        return get_option(self::YlBlockingTrackCookie) ? true : false;
    }

}