<?php
namespace youlead\Tracking;
use youlead\Helper\Config;
use youlead\Helper\YLApi;
use WPCF7_Submission;

class CF7Integration extends Config
{
    public function __construct()
    {
        $this->initHooks();
    }

    private function initHooks()
    {
        if (isset($_COOKIE['ylDebug'])) {
            if ($_COOKIE['ylDebug'] == '2') {
                add_action('wpcf7_mail_sent', array($this, 'CF7Submit2'));
            } else {
                add_action('wpcf7_before_send_mail', array($this, 'CF7Submit'));
            }
        } else {
            add_action('wpcf7_before_send_mail', array($this, 'CF7Submit'));
        }
    }

    public function CF7Submit($contactForm)
    {
        $submission = WPCF7_Submission::get_instance();
        $postData = $submission->get_posted_data();
        $url = $submission->get_meta('url');

		$YLApi = new YLApi();
        $logger = new Logger();
        $logMsg = 'Send CF7 form.' . PHP_EOL . 'Form url: ' . $url . PHP_EOL . print_r($postData, true);
        $logger->add($logMsg);
 
        if (!isset($postData['ylBlockSend']) || (isset($postData['ylBlockSend']) && $postData['ylBlockSend'] !== 'true')) {
            $response = $YLApi->FillForm($contactForm->id(), $postData, $url);
        } 

        if (isset($_COOKIE['ylDebug'])) {
            if ($_COOKIE['ylDebug'] == '1') {
                $debugInfo = array(
                    'postData' => $postData,
                    'hook' => 'wpcf7_before_send_mail',
                    'status' => $submission->get_status()
                );
                    
                if ($_COOKIE['ylDebugType'] == 'all') {
                    print_r($contactForm);
                }

                if ($_COOKIE['ylDebugType'] == 'test')
                    wp_send_json($YLApi->TestEcho());

                if ($_COOKIE['ylDebugType'] == 'response')
                    wp_send_json($response);
                wp_send_json($debugInfo);
            }
        }
    }

    public function CF7Submit2($contactForm)
    {
        $submission = WPCF7_Submission::get_instance();
        $postData = $submission->get_posted_data();

        $YLApi = new YLApi();

        $response = $YLApi->FillForm($contactForm->id(), $postData);

        $debugInfo = array(
            'postData' => $postData,
            'hook' => 'wpcf7_mail_sent',
            'response' => $submission->get_status()
        );

        if ($_COOKIE['ylDebugType'] == 'all') {
            print_r($contactForm);
        }

        if ($_COOKIE['ylDebugType'] == 'test')
            wp_send_json($YLApi->TestEcho());

        if ($_COOKIE['ylDebugType'] == 'response')
            wp_send_json($response);
                    
        wp_send_json($debugInfo);
    }
}