<?php
namespace youlead\Tracking;
use youlead\Helper\Config;

class Logger extends Config
{
    public function add($message)
    {
        if ($this->isLoggingEnabled())
            Logger::insertMessage($message);
    }

    protected function insertMessage($message)
    {
        $appendFile = true;

        if (file_exists(self::LogPath)) {
            $lastModified = date ('Y-m-d', filemtime(self::LogPath));
            
            if ($lastModified != date('Y-m-d'))
                $appendFile = false;
        }

        $msg = date('Y-m-d H:i:s') . PHP_EOL . $message . PHP_EOL;

        if ($appendFile)
            file_put_contents(self::LogPath, $msg, FILE_APPEND);
        else
            file_put_contents(self::LogPath, $msg);
    }
}