<?php
namespace youlead\Tracking;
use youlead\Helper\Config;

class TrackingCode extends Config
{
    private $clientId;

    public function __construct()
    {
        $this->init();
    }

    private function init()
    {
        $this->clientId = get_option(self::ClientId); 

        if ($this->clientId && !is_admin()) {
            add_action('wp_print_footer_scripts', array($this, 'createTrackingCode'));
        }
    }

	public function createTrackingCode()
	{
		if (!$this->clientId)
			return true;
	   
		if ($this->isBlockingTrackCookie()) {
			$cookieBotName = get_option(self::YLCookieBotName);
			if (isset($_COOKIE[$cookieBotName])) {
				try{
					$cookieBotAttrMap = get_option(self::YLCookieBotAttrMap);
					$cookieBotSeparator = get_option(self::YLCookieBotSeparator);
					$cookieBotAttrMap = preg_replace('/\s+/', '', $cookieBotAttrMap);
					$attributes = explode(';', $cookieBotAttrMap);
		
					if (empty($cookieBotSeparator)) {
						$cookieBotSeparator = ',';
					}
					$attrMapArray = [];
		
					foreach ($attributes as $attribute) {
						$attr = explode(':', $attribute);
						if (count($attr) === 2) {
							$attrMapArray[$attr[0]] = $attr[1];
						}
					}
					$consentCookie = $_COOKIE[$cookieBotName];
			
					// Parse the consent cookie
					$consentData = explode($cookieBotSeparator, $consentCookie);
					if (isset($_COOKIE['ylDebug'])) {
						echo '<script>';
						echo 'console.log(' . json_encode($consentData) . ');';
						echo 'console.log("separator: '.$cookieBotSeparator.'");';
						echo '</script>';
					}
					$allMatch = true;
	
					foreach ($attrMapArray as $key => $value) {
						if (isset($_COOKIE['ylDebug'])) {
							$localStorageScript = "<script type='text/javascript'>
							console.log('wymagane wartości ciastka: $key:$value');
							</script>";
						}
						print trim(preg_replace('/\s+/', ' ', $localStorageScript));
						if (!in_array("$key:$value", $consentData)) {
							$allMatch = false;
							break;
						}
					}
					if ($allMatch) {
						$localStorageScript = "<script type='text/javascript'>
						document.cookie = 'yltrack=true; path=/; domain=.' + window.location.hostname.replace(/^www\./, '');
						if (localStorage.getItem('yltrack') !== 'true') {
							localStorage.setItem('yltrack', 'true');
							
						}
						localStorage.setItem('yltrack', 'true');
						</script>";
						print trim(preg_replace('/\s+/', ' ', $localStorageScript));
					} else {
						$localStorageScript = "<script type='text/javascript'>
						if (localStorage.getItem('yltrack') !== 'false') {
							localStorage.setItem('yltrack', 'false');
						}
						</script>";
						print trim(preg_replace('/\s+/', ' ', $localStorageScript));
					}
				}
				catch (Exception $e) {
					if (isset($_COOKIE['ylDebug'])) {
						$localStorageScript = "<script type='text/javascript'>
						console.log('Błąd śledzenia: $e');
						</script>";
						print trim(preg_replace('/\s+/', ' ', $localStorageScript));
					}
				}
			}
			else
			{
				if (isset($_COOKIE['ylDebug'])) {
					$localStorageScript = "<script type='text/javascript'>
					console.log('Brak ciastka o nazwie: \"$cookieBotName\"');
					</script>";
					print trim(preg_replace('/\s+/', ' ', $localStorageScript));
				}
				$localStorageScript = "<script type='text/javascript'>
				if (localStorage.getItem('yltrack') !== 'false') {
					localStorage.setItem('yltrack', 'false');
				}
				</script>";
				print trim(preg_replace('/\s+/', ' ', $localStorageScript));
			}
		
        }
		   
        $code = "<script type='text/javascript'>
        /* YouLead Tracking Module v1.1.7 */
        var youleadId = '$this->clientId';
        var youleadDC = true; 
        
        (function() {
            var yl = document.createElement('script');
            yl.type = 'text/javascript';
            yl.async = true;
            yl.src = ('https:' == document.location.protocol ? 'https://' : 'http://') + 
                'm-' + youleadId + '.youlead.pl/m.js?ts=' + (new Date()).getTime();
            document.getElementsByTagName('body')[0].appendChild(yl);
        })();
        </script>";

        print trim(preg_replace('/\s+/', ' ', $code));
    }

}